<?php

// Mod by www.1-4a.com "What Searchengines? What Keywords? What Topics?"
// This mod shows what search engine sends visitors to what topic and with what keywords.
// Demo: http://www.dating-forum.com/showsearchenginereferers.php
// Demo: http://www.matrix-explained.com/php/showsearchenginereferers.php
// Demo: http://www.in-my-opinion.org/showsearchenginereferers.php
// Please also see the links at the bottom, with which you can sort/group the list

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
$last_xxx_days_to_show = 2;
$thisfilename = basename(__FILE__,'.'.$phpEx);
$timenow = time();
$topic_id = intval($_GET['topic_id']);
if ($topic_id > 0)
	{
	$topic_id = 0;
	}

$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

@require_once $phpbb_root_path.'1-4a_lang_parser.'.$phpEx;
getlanguage(__FILE__);

$loggedin = $userdata['session_logged_in'];
$userid = $userdata['user_id'];
$sesid = $userdata['session_id'];

if (!$loggedin)
	{
	// message_die(GENERAL_MESSAGE, 'You have to log in');
	}
	
// Change this (if you need to and if you actually use it)
$description_of_page_type[0] = 'a topic'; // Normal, don't change this
$description_of_page_type[-1] = 'the frontpage';
$description_of_page_type[-10] = 'our image galleries';
// Change this END

// Start output of page
// $gen_simple_header = TRUE;

$template->set_filenames(array(
	'cycletemplate' => ((intval(substr($thisfilename,-1)) > 0) ? substr($thisfilename,0,-1) : $thisfilename).'.tpl'
	)
	);
//$template->assign_block_vars('cycleme', array()); // Delete former

$groupby = $_GET['groupby'];

if ($topic_id < 0) // List special pages (= pages which are not viewtopic.php
	{
	switch (strtolower($groupby))
		{
		case 'referer':
			$sqlgroupby = ' GROUP BY seg.referer';
			$sqlorderby = ' ORDER BY countsearch DESC ';
			$deletesearchedfor = 1;
			$deletetimedif = 1;
			$deletetopic = 1;
			$deletestarter = 1;
			$deletesearchedfor = 1;
			break;
		case 'topic': // OK, it's not topic per se but the URL
			$sqlgroupby = ' GROUP BY seg.url';
			$sqlorderby = ' ORDER BY countsearch DESC ';
			$deletesearchedfor = 1;
			$deletereferer = 1;
			$deletetimedif = 1;
			$deletesearchedfor = 1;
			break;
		default:
			$sqlgroupby = ' GROUP BY seg.search';
			$sqlorderby = ' ORDER BY countsearch DESC, maxtime DESC';
			$deletetimedif = 1;
			
			// If you want to sort by time (= latest searches first) then use the following
			// $sqlorderby = ' ORDER BY maxtime DESC '; 
			// $deletetimedif = 0;
			// and use in your templates {SECONDSDIFF}, {MINUTESAGO} and {MINUTES}
			break;
		}

	$sql=	 ' SELECT	seg.url, seg.description, seg.search, seg.topic_id, seg.referer, max(seg.time) as maxtime, count(seg.search) as countsearch '
		.' FROM	'.$table_prefix.'searchenginereferers'.' seg '
		.' where '
		.'		seg.time >= '.(time()-(60*60*24*$last_xxx_days_to_show)) // Show only last xxx days -> Faster
		.'	and	seg.topic_id = '.$topic_id
		.$sqlgroupby
		.$sqlorderby
		.'';
	}
else // Normal
	{
	switch (strtolower($groupby))
		{
		case 'referer':
			$sqlgroupby = ' GROUP BY seg.referer';
			$sqlorderby = ' ORDER BY countsearch DESC ';
			$deletetimedif = 1;
			$deletetopic = 1;
			$deleteforum = 1;
			$deletestarter = 1;
			$deletesearchedfor = 1;
			break;
		case 'topic':
			$sqlgroupby = ' GROUP BY seg.topic_id';
			$sqlorderby = ' ORDER BY countsearch DESC ';
			$deletereferer = 1;
			$deletetimedif = 1;
			$deletesearchedfor = 1;
			break;
		case 'forum':
			$sqlgroupby = ' GROUP BY f.forum_name';
			$sqlorderby = ' ORDER BY countsearch DESC ';
			$deletetimedif = 1;
			$deletetopic = 1;
			$deletestarter = 1;
			$deletereferer = 1;
			$deletesearchedfor = 1;
			break;
		case 'starter':
			$sqlgroupby = ' GROUP BY u.user_id';
			$sqlorderby = ' ORDER BY countsearch DESC ';
			$deletetimedif = 1;
			$deletetopic = 1;
			$deleteforum = 1;
			$deletereferer = 1;
			$deletesearchedfor = 1;
			break;
		default:
			$sqlgroupby = ' GROUP BY seg.search';
			$sqlorderby = ' ORDER BY countsearch DESC, maxtime DESC';
			$deletetimedif = 1;
			
			// If you want to sort by time (= latest searches first) then use the following
			// $sqlorderby = ' ORDER BY maxtime DESC '; 
			// $deletetimedif = 0;
			// and use in your templates {SECONDSDIFF}, {MINUTESAGO} and {MINUTES}
			break;
		}
	
	$sql=	 ' SELECT	seg.url, seg.description, seg.search, seg.topic_id, seg.referer, max(seg.time) as maxtime, count(seg.search) as countsearch, t.topic_title, f.forum_name, u.username as topicstartername, u.user_id as topicstarterid, p.post_username as usernameanon'
		.' FROM	'.$table_prefix.'searchenginereferers'.' seg, '.TOPICS_TABLE.' t, '.FORUMS_TABLE.' f, '.USERS_TABLE.' u, '.POSTS_TABLE.' p '
		.' where '
		.'		seg.time >= '.(time()-(60*60*24*$last_xxx_days_to_show)) // Show only last xxx days -> Faster
		.'	and	t.topic_id > 0 '
		.'	and	t.forum_id = f.forum_id '
		.'	and	t.topic_id = seg.topic_id '
		.'	and	t.topic_first_post_id = p.post_id '
		.'	and	p.poster_id = u.user_id '
		.$sqlgroupby
		.$sqlorderby
		.'';
	}
if ($userdata['user_level'] == ADMIN)
	{
	// echo $sql;
	}

$result = $db->sql_query($sql);
$i = 0;
$lasttime = time();
while (($row = $db->sql_fetchrow($result)) )
	{
	$i++;
	$timediff = $lasttime-$row['maxtime'];
	$description = htmlspecialchars(html_entity_decode($row['topic_title']));
	
	if (!$description)
		{
		$description = htmlspecialchars(html_entity_decode($row['description']));
		}
	
	if (!$description)
		{
		$description = htmlspecialchars(html_entity_decode($row['url']));
		}
	
	$topicstarterid = $row['topicstarterid'];
	$topicstartername = ($topicstarterid == ANONYMOUS) ? $row['usernameanon'] : $row['topicstartername'];
	$linktoprofile = ($topicstarterid == ANONYMOUS) ? $topicstartername : knn_makelink('profile.'.$phpEx.'?mode=viewprofile&amp;u='.$topicstarterid,$topicstartername);
	$morethan1 = $row['countsearch'] > 1;
	
	$template->assign_block_vars('cycleme', array( // Variables within the <--- BEGIN/END cycleme ---> part
		'ROW_CLASS' => ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'],
		'SEARCHED' => ($deletesearchedfor && $morethan1) ? '-' : $lang['ser_leftquot'].htmlspecialchars($row['search']).$lang['ser_rightquot'],
		'DESCRIPTION' => $description,
		'LINK_TO_PAGE' => ($deletetopic && $morethan1) ? '-' : knn_makelink($row['url'],$description),
		'FORUM' => (($deleteforum && $morethan1) || ($topic_id < 0)) ? '-' : $row['forum_name'],
		'TIMES' => $morethan1 ? $row['countsearch'].'x' : '&nbsp;',
		'TITLE' => $topictitle, // Usually not needed
		'TOPICID' => $row['topic_id'],  // Usually not needed
		'URL' => $row['url'], // Usually not needed
		'REFERER' => ($deletereferer && $morethan1) ? '-' : $row['referer'],
		'TOPICSTARTER' => (($deletestarter && $morethan1) || ($topic_id < 0)) ? '-' : $linktoprofile,
		'SECONDSDIFF' => $deletetimedif ? '-' : date('i:s',$timediff),
		'MINUTESAGO' => $deletetimedif ? '&nbsp;' : ($i == 1 ? $lang['ser_ago'] : ''),
		'MINUTES' => $deletetimedif ? '&nbsp;' : ($i == 1 ? '' : $lang['ser_minutes'])
		)
		);
	$lasttime = $row['maxtime'];
	}
	
$sql=	 ' SELECT	max(seg.time) as maxtime '
	.' FROM	'.$table_prefix.'searchenginereferers'.' seg '
	.' where '
	.' '.($topic_id == 0 ? 'seg.topic_id > 0' : 'seg.topic_id = '.$topic_id)
	.'	and	seg.time >= '.(time()-(60*60*24*$last_xxx_days_to_show)) // Show only last xxx days -> Faster
	.' GROUP BY seg.ip ' // Combine same searches by 1 user into 1
	.' ORDER BY maxtime DESC '
	.'';

if ($userdata['user_level'] == ADMIN)
	{
	//echo $sql;
	}
	
$oldestreferertime = 0;
$addtimes = 0;

if ($result = $db->sql_query($sql))
	{
	while (($row = $db->sql_fetchrow($result)) )
		{
		$addtimes++;
		$oldestreferertime = $row['maxtime'];
		}
	}

$difftime = $addtimes > 0 ? round((time()-$oldestreferertime)/$addtimes) : 0;
$l_interval = $lang['ser_seconds'];
if ($difftime > 120) // A user comes less frequent than ever 120 seconds
	{
	if ($difftime > 3600) // A user comes less frequent than every 60 minutes
		{
		$difftime = round($difftime/3600,1);
		$l_interval = $lang['ser_hours'];
		}
	else
		{
		$difftime = round($difftime/60);
		$l_interval = $lang['ser_minutes'];
		}
	}
	
$linktootherpage = '';
$sql=	 ' SELECT distinct seg.topic_id '
	.' FROM	'.$table_prefix.'searchenginereferers'.' seg '
	.' where seg.topic_id < 0 '
	.'';

if ($result = $db->sql_query($sql))
	{
	while (($row = $db->sql_fetchrow($result)) )
		{
		if (($row['topic_id'] != $topic_id) && ($description_of_page_type[$row['topic_id']]))
			{
			$linktootherpage .= ' '.knn_makelink(knn_append_query('','topic_id='.intval($row['topic_id'])),sprintf($lang['ser_clicktoview'],$description_of_page_type[$row['topic_id']]));
			}
		}
	}


$basiclink = knn_append_query('','topic_id='.$topic_id);
$template->assign_vars(array( // General variables
	'TIMENOW' => $timenow,
	'META' => '<META NAME="ROBOTS" CONTENT="NOINDEX,NOFOLLOW">',
	'L_SEARCHED' => $lang['ser_searched'],
	'L_FOUND' => $lang['ser_found'],
	'L_REFERER' => $lang['ser_referer'],
	'L_FORUM' => $lang['ser_forum'],
	'L_TOPICSTARTER' => $lang['ser_topicstarter'],
	
	'LINK_GROUPBY_KEYWORDS'		=> knn_makelink(knn_append_query($basiclink,''),$lang['ser_groupby_keywords']), // default
	'LINK_GROUPBY_TOPIC'		=> knn_makelink(knn_append_query($basiclink,'groupby=topic'),$lang['ser_groupby_topic']),
	'LINK_GROUPBY_SEARCHENGINES'	=> knn_makelink(knn_append_query($basiclink,'groupby=referer'),$lang['ser_groupby_searcheengine']),
	'LINK_GROUPBY_FORUM'		=> ($topic_id < 0) ? '' : knn_makelink(knn_append_query($basiclink,'groupby=forum'),$lang['ser_groupby_forum']),
	'LINK_GROUPBY_TOPICSTARTER'	=> ($topic_id < 0) ? '' : knn_makelink(knn_append_query($basiclink,'groupby=starter'),$lang['ser_groupby_topicstarter']),
	
	'L_SECONDSDIFF' => $lang['ser_secondsdiff'],
	'AVERAGE_DIFF' => ($addtimes > 0) ? sprintf($lang['ser_averagediff'],$description_of_page_type[$topic_id],$difftime).$l_interval : '&nbsp;',
	'LINK_OTHERTOPICS' => $linktootherpage
	)
	);
	
	
$page_title = ucwords(str_replace('_',' ',$thisfilename));
$page_title = sprintf($lang['ser_pagetitle'],$description_of_page_type[$topic_id],$last_xxx_days_to_show,$addtimes);

// Generate the page
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

$template->pparse('cycletemplate');
echo '<br /><br /><span class="gensmall" style="text-align:right; width:100%"><a href="http://www.1-4a.com">php B.B. Mod by 1-4a.com</a></span>';
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>